/*
 * Here, in the project level include file, I've defined some structures
 * to handle the config format for strings. I basically have two types,
 * a forty character type for device and file names, QeM_Dat etc, and a
 * sixteen character type for Hayes command strings.
 */
 
typedef struct {
    short max;
    short len;
    char  Text[40];
} CONF40;

typedef struct {
    short max;
    short len;
    char  Text[16];
} CONF16;

/*
 * This is the C level config block, the actual data has to be defined
 * at (GST) assembler level, as it uses relative pointers. Easier to do
 * this stuff in asm than frig it in C.
 */

typedef struct
{
    CONF40 CapFile;
    CONF40 SendFile;
    CONF40 XmRFile;
    CONF40 XmSFile;
    CONF40 Qem_Dat;
    CONF40 Qbook_dat;
    CONF16 Hayes[7];
}
CONFIG, *PCONFIG;

extern CONFIG QM;


