 
********************************************************************
*
*   GST Asm format defines config data and does post processing
* 
********************************************************************

* Define a QD_text type string

string$ macro A
[.lab]  dc.w    .e.[.l]-.s.[.l]
.s.[.l] dc.b    [A]
.e.[.l]
        ds.w    0
        endm

* Define a Config string item, max size, then a QD_text (len,chrs),
* and then some blank ds.b stuff to pad to max size. 

conf$   macro   A B
[.lab]  dc.w    [A]
        dc.w    .e.[.l]-.s.[.l]
.s.[.l] dc.b    [B]
.e.[.l]
        dc.b    0
        ds.b    ([A]-1-.e.[.l]+.s.[.l])
        ds.w    0
        endm

* These are the external references we need. They have to be defined in
* this module. A bit messy really. In QTPI I xdef QeMNAME and QeMVER so
* I only have to update one module with version changes.
        
        xdef    QM
        xdef    patch

* Config data and code follows, can be in section text or data if you
* want, just must be within 32K of each other

        section config

* I'm paranoid about odd addresses, hence a lot of ds.w 0

        ds.w    0

* The mandatory config header

        dc.b    '<<QCFX>>01'
QeMNAME string$ {'QeM'}
        ds.w    0
QeMVER  string$ '3.8b'
        ds.w    0 

* The config items follow, in the format described in the QPTR manual
* page 152-153

        dc.b    0                           ; type, string
        dc.b    'A'                         ; selection letter
        dc.w    i1-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    t1-*                        ; descriptive text
        dc.w    x1-*                        ; attributes

        dc.b    0                           ; type string
        dc.b    'B'                         ; sel letter
        dc.w    i2-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    t2-*                        ; text
        dc.w    x2-*                        ; attributes

        dc.b    0
        dc.b    'C'
        dc.w    i3-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    t3-*                        ; text
        dc.w    x3-*                        ; attributes

        dc.b    0
        dc.b    'D'
        dc.w    i4-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    t4-*                        ; text
        dc.w    x4-*                        ; attributes

        dc.b    0
        dc.b    'E'
        dc.w    i5-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    t5-*                        ; text
        dc.w    x5-*                        ; attributes

        dc.b    0
        dc.b    'F'
        dc.w    i6-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    t6-*                        ; text
        dc.w    x6-*                        ; attributes

***     There is no i/t/x7
***     This is a QeM feature of the way its coded, the
***     dial item which would have gone here is configurable
***     at runtime. We need the space in the structure though.

        dc.b    0
        dc.b    'G'
        dc.w    i8-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    t8-*                        ; text
        dc.w    x8-*                        ; attributes

        dc.b    0
        dc.b    'H'
        dc.w    i9-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    t9-*                        ; text
        dc.w    x9-*                        ; attributes

        dc.b    0
        dc.b    'I'
        dc.w    ia-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    ta-*                        ; text
        dc.w    xa-*                        ; attributes

        dc.b    0
        dc.b    'J'
        dc.w    ib-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    tb-*                        ; text
        dc.w    xb-*                        ; attributes

        dc.b    0
        dc.b    'K'
        dc.w    ic-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    tc-*                        ; text
        dc.w    xc-*                        ; attributes

        dc.b    0
        dc.b    'L'
        dc.w    id-*                        ; first item
        dc.w    0                           ; pre-process
        dc.w    Postit-*                    ; post-process
        dc.w    td-*                        ; text
        dc.w    xd-*                        ; attributes

* The last item is a 'code' type. Did I crash the system a bit getting
* this lot to work ?
      
        dc.b    4                           ; type is code
        dc.b    0                           ; step thru values
        dc.w    patch-*                     ; data item
        dc.w    0                           ; no pre process
        dc.w    0                           ; no post process
        dc.w    pt-*                        ; text
        dc.w    xx-*                        ; item attributes
        
        dc.w    -1                          ; end of config list

patch   dc.b    1                           ; QL/ST Patch flag

        ds.w    0

* Data for the patch item 
* pt is just the description string
        
pt      string$ {'Host Type'}
        ds.w    0

* the item attrbute, seriously confusing. Each entry is a byte value,
* byte keystroke, QD_text description. -1 terminates list       

xx      dc.b    0                           ; value of this text selection
        dc.b    0                           ; no keystroke
        string$ {'QL Only (crash ST)'}      ; text for this value
        ds.w    0                           ; get even
        dc.b    1                           ; value of this text selection
        dc.b    0                           ; no keystroke
        string$ {'QL or ST (safe hex)'}     ; text for this item
        dc.w    -1                          ; terminator too

* The attributes for the string items, as it's all the same, I guess
* we could have jusy re-used the same word and save all of 20 words.
        
x1      dc.w    0
x2      dc.w    0
x3      dc.w    0
x4      dc.w    0
x5      dc.w    0
x6      dc.w    0
x8      dc.w    0
x9      dc.w    0
xa      dc.w    0
xb      dc.w    0
xc      dc.w    0
xd      dc.w    0

* The QM definition maps onto the 'C' QM structure. It pre-defines the 
* default values.

QM
i1      conf$   40,{'ram2_QeM_'}
i2      conf$   40,{'ram2_'}
i3      conf$   40,{'ram2_Xmd_'}
i4      conf$   40,{'ram2_'}
i5      conf$   40,{'flp1_qem_dat'}
i6      conf$   40,{'flp2_qbook_dat'}
i7      dc.w    16                  ; just a filler (not processed by Config)
        dc.w    0
        ds.b    16
i8      conf$   16,{'+++\|\~ATH0\r'}
i9      conf$   16,{'ATH1\r'}
ia      conf$   16,{'ATA\r'}
ib      conf$   16,{'ATS0=2\r'}
ic      conf$   16,{'+++\|\~ATZ\r'}
id      conf$   16,{'ATI0I1I2I3\r'}
        ds.w    0

* The config prompt text strings

t1      string$ {'Capture to'}
t2      string$ {'Send from'}
t3      string$ {'XModem to'}
t4      string$ {'XModem from'}
t5      string$ {'Default QeM_dat'}
t6      string$ {'Default QBook_dat'}
t8      string$ {'Modem Disconnect'}
t9      string$ {'Modem Connect'}
ta      string$ {'Modem Answer'}
tb      string$ {'Modem AutoAnswer'}
tc      string$ {'Modem Reset'}
td      string$ {'Modem Version'}
        ds.w    0

* This little bit of code is called by the Config program to do
* the post processing. It adds a NUL to the end of the strings for 'C'.
* Considering now simple it is, it is a interesting that I managed to
* screw it up twice.

Postit
*
*       a0 = pointer to item
*           0(a0) == max length
*           2(a0) == actual length
*           4(a0) == start of text
*
        move.w  2(a0),d2                            ; the length
        move.b  #0,4(a0,d2.w)                       ; all set for 'C'        
        moveq   #0,d0                               ; return OK
        rts
        end

